#include "RGBmatrixPanel.h"

#define A   A0
#define B   A1
#define C   A2
#define CLK 8
#define LAT A3
#define OE  9
#define WIDTH 32

int count = 0;
byte currentByte = 0;
byte lastByte = 0;
uint16_t color;
RGBmatrixPanel matrix(A, B, C, CLK, LAT, OE, true);

void setup() 
{ 
  Serial.begin(115200); 
  matrix.begin();
} 

void loop() {
  int index;
  while (Serial.available()) {

    lastByte = currentByte;
    currentByte = Serial.read();
    
    // Look for the frame marker 0xF000
    if ((lastByte == 0xF0) && (currentByte == 0x00)) {
      count = 0;
      matrix.swapBuffers(false);
    } else {
      if ((count % 2) == 1) {
	color = (lastByte << 8) | currentByte;
	index = (count-1)/2;
	matrix.drawPixel(index % WIDTH, index / WIDTH, color);
      }
      count++;
    }
  }
} 
